Index: LMDZ6/branches/Ocean_skin/libf/phylmd/dyn1d/mod_1D_cases_read2.F90
===================================================================
--- LMDZ6/branches/Ocean_skin/libf/phylmd/dyn1d/mod_1D_cases_read2.F90	(revision 4013)
+++ LMDZ6/branches/Ocean_skin/libf/phylmd/dyn1d/mod_1D_cases_read2.F90	(revision 4368)
@@ -731,11 +718,7 @@
               stop "getvarup"
            endif
-!-----------------------------------------------------------------------
-           else if(i.gt.4.and.i.LE.45) then   ! Lecture des variables en (time,nlevel,lat,lon)
-#ifdef NC_DOUBLE
-           ierr = NF_GET_VAR_DOUBLE(nid,var3didin(i),resul)
-#else
-           ierr = NF_GET_VAR_REAL(nid,var3didin(i),resul)
-#endif
+           !-----------------------------------------------------------------------
+        else if(i.gt.4.and.i.LE.45) then   ! Lecture des variables en (time,nlevel,lat,lon)
+           ierr = NF90_GET_VAR(nid,var3didin(i),resul, count = [1, 1, nlevel, ntime])
            print *,'read2_cas(resul), on a lu ',i,name_var(i)
            if(ierr/=NF_NOERR) then
@@ -743,11 +726,7 @@
               stop "getvarup"
            endif
-!-----------------------------------------------------------------------
-           else if (i.gt.45.and.i.LE.51) then   ! Lecture des variables en (time,lat,lon)
-#ifdef NC_DOUBLE
-           ierr = NF_GET_VAR_DOUBLE(nid,var3didin(i),resul2)
-#else
-           ierr = NF_GET_VAR_REAL(nid,var3didin(i),resul2)
-#endif
+           !-----------------------------------------------------------------------
+        else if (i.gt.45.and.i.LE.51) then   ! Lecture des variables en (time,lat,lon)
+           ierr = NF90_GET_VAR(nid,var3didin(i),resul2, count = [1, 1, ntime])
            print *,'read2_cas(resul2), on a lu ',i,name_var(i)
            if(ierr/=NF_NOERR) then
@@ -755,11 +734,7 @@
               stop "getvarup"
            endif
-!-----------------------------------------------------------------------
-           else     ! Lecture des constantes (lat,lon)
-#ifdef NC_DOUBLE
-           ierr = NF_GET_VAR_DOUBLE(nid,var3didin(i),resul3)
-#else
-           ierr = NF_GET_VAR_REAL(nid,var3didin(i),resul3)
-#endif
+           !-----------------------------------------------------------------------
+        else     ! Lecture des constantes (lat,lon)
+           ierr = NF90_GET_VAR(nid,var3didin(i),resul3)
            print *,'read2_cas(resul3), on a lu ',i,name_var(i)
            if(ierr/=NF_NOERR) then
@@ -767,155 +742,152 @@
               stop "getvarup"
            endif
-           endif
-         endif
-!-----------------------------------------------------------------------
-         select case(i)
-           case(1) ; ap=apbp       ! donnees indexees en nlevel+1
-           case(2) ; bp=apbp
-           case(3) ; zzh=apbp
-           case(4) ; pph=apbp
-           case(5) ; vitw=resul    ! donnees indexees en nlevel,time
-           case(6) ; omega=resul
-           case(7) ; ug=resul
-           case(8) ; vg=resul
-           case(9) ; du=resul
-           case(10) ; hu=resul
-           case(11) ; vu=resul
-           case(12) ; dv=resul
-           case(13) ; hv=resul
-           case(14) ; vv=resul
-           case(15) ; dt=resul
-           case(16) ; ht=resul
-           case(17) ; vt=resul
-           case(18) ; dq=resul
-           case(19) ; hq=resul
-           case(20) ; vq=resul
-           case(21) ; dth=resul
-           case(22) ; hth=resul
-           case(23) ; vth=resul
-           case(24) ; hthl=resul
-           case(25) ; dr=resul
-           case(26) ; hr=resul
-           case(27) ; vr=resul
-           case(28) ; dtrad=resul
-           case(29) ; q1=resul
-           case(30) ; q2=resul
-           case(31) ; uw=resul
-           case(32) ; vw=resul
-           case(33) ; rh=resul
-           case(34) ; zz=resul      ! donnees en time,nlevel pour profil initial
-           case(35) ; pp=resul
-           case(36) ; temp=resul
-           case(37) ; theta=resul
-           case(38) ; thv=resul
-           case(39) ; thl=resul
-           case(40) ; qv=resul
-           case(41) ; ql=resul
-           case(42) ; qi=resul
-           case(43) ; rv=resul
-           case(44) ; u=resul
-           case(45) ; v=resul
-           case(46) ; sens=resul2   ! donnees indexees en time
-           case(47) ; flat=resul2
-           case(48) ; ts=resul2
-           case(49) ; ps=resul2
-           case(50) ; ustar=resul2
-           case(51) ; tke=resul2
-           case(52) ; orog_cas=resul3      ! constantes
-           case(53) ; albedo_cas=resul3
-           case(54) ; emiss_cas=resul3
-           case(55) ; t_skin_cas=resul3
-           case(56) ; q_skin_cas=resul3
-           case(57) ; mom_rough=resul3
-           case(58) ; heat_rough=resul3
-           case(59) ; o3_cas=resul3        
-           case(60) ; rugos_cas=resul3
-           case(61) ; clay_cas=resul3
-           case(62) ; sand_cas=resul3
-         end select
-         resul=0.
-         resul1=0.
-         resul2=0.
-         resul3=0.
-       enddo
-!-----------------------------------------------------------------------
-
-
-         return 
-         end subroutine read2_cas
+        endif
+     endif
+     !-----------------------------------------------------------------------
+     select case(i)
+     case(1) ; ap=apbp       ! donnees indexees en nlevel+1
+     case(2) ; bp=apbp
+     case(3) ; zzh=apbp
+     case(4) ; pph=apbp
+     case(5) ; vitw=resul    ! donnees indexees en nlevel,time
+     case(6) ; omega=resul
+     case(7) ; ug=resul
+     case(8) ; vg=resul
+     case(9) ; du=resul
+     case(10) ; hu=resul
+     case(11) ; vu=resul
+     case(12) ; dv=resul
+     case(13) ; hv=resul
+     case(14) ; vv=resul
+     case(15) ; dt=resul
+     case(16) ; ht=resul
+     case(17) ; vt=resul
+     case(18) ; dq=resul
+     case(19) ; hq=resul
+     case(20) ; vq=resul
+     case(21) ; dth=resul
+     case(22) ; hth=resul
+     case(23) ; vth=resul
+     case(24) ; hthl=resul
+     case(25) ; dr=resul
+     case(26) ; hr=resul
+     case(27) ; vr=resul
+     case(28) ; dtrad=resul
+     case(29) ; q1=resul
+     case(30) ; q2=resul
+     case(31) ; uw=resul
+     case(32) ; vw=resul
+     case(33) ; rh=resul
+     case(34) ; zz=resul      ! donnees en time,nlevel pour profil initial
+     case(35) ; pp=resul
+     case(36) ; temp=resul
+     case(37) ; theta=resul
+     case(38) ; thv=resul
+     case(39) ; thl=resul
+     case(40) ; qv=resul
+     case(41) ; ql=resul
+     case(42) ; qi=resul
+     case(43) ; rv=resul
+     case(44) ; u=resul
+     case(45) ; v=resul
+     case(46) ; sens=resul2   ! donnees indexees en time
+     case(47) ; flat=resul2
+     case(48) ; ts=resul2
+     case(49) ; ps=resul2
+     case(50) ; ustar=resul2
+     case(51) ; tke=resul2
+     case(52) ; orog_cas=resul3      ! constantes
+     case(53) ; albedo_cas=resul3
+     case(54) ; emiss_cas=resul3
+     case(55) ; t_skin_cas=resul3
+     case(56) ; q_skin_cas=resul3
+     case(57) ; mom_rough=resul3
+     case(58) ; heat_rough=resul3
+     case(59) ; o3_cas=resul3        
+     case(60) ; rugos_cas=resul3
+     case(61) ; clay_cas=resul3
+     case(62) ; sand_cas=resul3
+     end select
+     resul=0.
+     resul1=0.
+     resul2=0.
+     resul3=0.
+  enddo
+  !-----------------------------------------------------------------------
+
+
+  return 
+end subroutine read2_cas
 
 !======================================================================
-      subroutine old_read_SCM(nid,nlevel,ntime,                                       &
-     &     ap,bp,zz,pp,zzh,pph,temp,theta,thv,thl,qv,ql,qi,rh,rv,u,v,vitw,omega,ug,vg,&
-     &     du,hu,vu,dv,hv,vv,dt,ht,vt,dq,hq,vq,                                    &
-     &     dth,hth,vth,dr,hr,vr,dtrad,sens,flat,ts,ps,ustar,tke,uw,vw,q1,q2,       &
-     &     orog_cas,albedo_cas,emiss_cas,t_skin_cas,q_skin_cas,mom_rough,          &
-     &     heat_rough,o3_cas,rugos_cas,clay_cas,sand_cas)
-
-!program reading forcing of the case study
-      implicit none
+subroutine old_read_SCM(nid,nlevel,ntime,                                       &
+     ap,bp,zz,pp,zzh,pph,temp,theta,thv,thl,qv,ql,qi,rh,rv,u,v,vitw,omega,ug,vg,&
+     du,hu,vu,dv,hv,vv,dt,ht,vt,dq,hq,vq,                                    &
+     dth,hth,vth,dr,hr,vr,dtrad,sens,flat,ts,ps,ustar,tke,uw,vw,q1,q2,       &
+     orog_cas,albedo_cas,emiss_cas,t_skin_cas,q_skin_cas,mom_rough,          &
+     heat_rough,o3_cas,rugos_cas,clay_cas,sand_cas)
+
+  !program reading forcing of the case study
+  use netcdf, only: nf90_get_var
+  implicit none
 #include "netcdf.inc"
 
-      integer ntime,nlevel,k,t
-
-      real ap(nlevel+1),bp(nlevel+1)
-      real zz(nlevel,ntime),zzh(nlevel+1)
-      real pp(nlevel,ntime),pph(nlevel+1)
-!profils initiaux
-      real temp0(nlevel),qv0(nlevel),ql0(nlevel),qi0(nlevel),u0(nlevel),v0(nlevel),tke0(nlevel)
-      real pp0(nlevel)    
-      real temp(nlevel,ntime),qv(nlevel,ntime),ql(nlevel,ntime),qi(nlevel,ntime),rh(nlevel,ntime)
-      real theta(nlevel,ntime),thv(nlevel,ntime),thl(nlevel,ntime),rv(nlevel,ntime)
-      real u(nlevel,ntime),v(nlevel,ntime),tke(nlevel,ntime)
-      real ug(nlevel,ntime),vg(nlevel,ntime)
-      real vitw(nlevel,ntime),omega(nlevel,ntime)
-      real du(nlevel,ntime),hu(nlevel,ntime),vu(nlevel,ntime)
-      real dv(nlevel,ntime),hv(nlevel,ntime),vv(nlevel,ntime)
-      real dt(nlevel,ntime),ht(nlevel,ntime),vt(nlevel,ntime)
-      real dtrad(nlevel,ntime)
-      real dq(nlevel,ntime),hq(nlevel,ntime),vq(nlevel,ntime)
-      real dth(nlevel,ntime),hth(nlevel,ntime),vth(nlevel,ntime),hthl(nlevel,ntime)
-      real dr(nlevel,ntime),hr(nlevel,ntime),vr(nlevel,ntime)
-      real flat(ntime),sens(ntime),ustar(ntime)
-      real uw(nlevel,ntime),vw(nlevel,ntime),q1(nlevel,ntime),q2(nlevel,ntime)
-      real ts(ntime),ps(ntime)
-      real orog_cas,albedo_cas,emiss_cas,t_skin_cas,q_skin_cas,mom_rough,heat_rough,o3_cas,rugos_cas,clay_cas,sand_cas
-      real apbp(nlevel+1),resul(nlevel,ntime),resul1(nlevel),resul2(ntime),resul3
-
-
-      integer nid, ierr,ierr1,ierr2,rid,i
-      integer nbvar3d
-      parameter(nbvar3d=70)
-      integer var3didin(nbvar3d),missing_var(nbvar3d)
-      character*13 name_var(1:nbvar3d)
-      data name_var/'coor_par_a','coor_par_b','height_h','pressure_h',&
-     &'temp','qv','ql','qi','u','v','tke','pressure',&
-     &'w','omega','ug','vg','uadv','uadvh','uadvv','vadv','vadvh','vadvv','tadv','tadvh','tadvv',&
-     &'qvadv','qvadvh','qvadvv','thadv','thadvh','thadvv','thladvh','radv','radvh','radvv','radcool','q1','q2','ustress','vstress', &
-     'rh',&
-     &'height_f','pressure_forc','tempt','theta','thv','thl','qvt','qlt','qit','rv','ut','vt','tket',&
-     &'sfc_sens_flx','sfc_lat_flx','ts','ps','ustar',&
-     &'orog','albedo','emiss','t_skin','q_skin','mom_rough','heat_rough','o3','rugos','clay','sand'/
-      do i=1,nbvar3d
-        missing_var(i)=0.
-      enddo
-
-!-----------------------------------------------------------------------
-
-     print*,'ON EST LA'
-       do i=1,nbvar3d
-         ierr=NF_INQ_VARID(nid,name_var(i),var3didin(i)) 
-         if(ierr/=NF_NOERR) then
-           print *,'Variable manquante dans cas.nc:',i,name_var(i)
-           ierr=NF_NOERR
-           missing_var(i)=1
-         else
-!-----------------------------------------------------------------------
-           if(i.LE.4) then     ! Lecture des coord pression en (nlevelp1,lat,lon)
-#ifdef NC_DOUBLE
-           ierr = NF_GET_VAR_DOUBLE(nid,var3didin(i),apbp)
-#else
-           ierr = NF_GET_VAR_REAL(nid,var3didin(i),apbp)
-#endif
+  integer ntime,nlevel,k,t
+
+  real ap(nlevel+1),bp(nlevel+1)
+  real zz(nlevel,ntime),zzh(nlevel+1)
+  real pp(nlevel,ntime),pph(nlevel+1)
+  !profils initiaux
+  real temp0(nlevel),qv0(nlevel),ql0(nlevel),qi0(nlevel),u0(nlevel),v0(nlevel),tke0(nlevel)
+  real pp0(nlevel)    
+  real temp(nlevel,ntime),qv(nlevel,ntime),ql(nlevel,ntime),qi(nlevel,ntime),rh(nlevel,ntime)
+  real theta(nlevel,ntime),thv(nlevel,ntime),thl(nlevel,ntime),rv(nlevel,ntime)
+  real u(nlevel,ntime),v(nlevel,ntime),tke(nlevel,ntime)
+  real ug(nlevel,ntime),vg(nlevel,ntime)
+  real vitw(nlevel,ntime),omega(nlevel,ntime)
+  real du(nlevel,ntime),hu(nlevel,ntime),vu(nlevel,ntime)
+  real dv(nlevel,ntime),hv(nlevel,ntime),vv(nlevel,ntime)
+  real dt(nlevel,ntime),ht(nlevel,ntime),vt(nlevel,ntime)
+  real dtrad(nlevel,ntime)
+  real dq(nlevel,ntime),hq(nlevel,ntime),vq(nlevel,ntime)
+  real dth(nlevel,ntime),hth(nlevel,ntime),vth(nlevel,ntime),hthl(nlevel,ntime)
+  real dr(nlevel,ntime),hr(nlevel,ntime),vr(nlevel,ntime)
+  real flat(ntime),sens(ntime),ustar(ntime)
+  real uw(nlevel,ntime),vw(nlevel,ntime),q1(nlevel,ntime),q2(nlevel,ntime)
+  real ts(ntime),ps(ntime)
+  real orog_cas,albedo_cas,emiss_cas,t_skin_cas,q_skin_cas,mom_rough,heat_rough,o3_cas,rugos_cas,clay_cas,sand_cas
+  real apbp(nlevel+1),resul(nlevel,ntime),resul1(nlevel),resul2(ntime),resul3
+
+
+  integer nid, ierr,ierr1,ierr2,rid,i
+  integer nbvar3d
+  parameter(nbvar3d=70)
+  integer var3didin(nbvar3d),missing_var(nbvar3d)
+  character*13 name_var(1:nbvar3d)
+  data name_var/'coor_par_a','coor_par_b','height_h','pressure_h',&
+       'temp','qv','ql','qi','u','v','tke','pressure',&
+       'w','omega','ug','vg','uadv','uadvh','uadvv','vadv','vadvh','vadvv','tadv','tadvh','tadvv',&
+       'qvadv','qvadvh','qvadvv','thadv','thadvh','thadvv','thladvh','radv','radvh','radvv','radcool','q1','q2','ustress', &
+       'vstress','rh',&
+       'height_f','pressure_forc','tempt','theta','thv','thl','qvt','qlt','qit','rv','ut','vt','tket',&
+       'sfc_sens_flx','sfc_lat_flx','ts','ps','ustar',&
+       'orog','albedo','emiss','t_skin','q_skin','mom_rough','heat_rough','o3','rugos','clay','sand'/
+  do i=1,nbvar3d
+     missing_var(i)=0.
+  enddo
+
+  !-----------------------------------------------------------------------
+
+  print*,'ON EST LA'
+  do i=1,nbvar3d
+     ierr=NF_INQ_VARID(nid,name_var(i),var3didin(i)) 
+     if(ierr/=NF_NOERR) then
+        print *,'Variable manquante dans cas.nc:',i,name_var(i)
+        ierr=NF_NOERR
+        missing_var(i)=1
+     else
+        !-----------------------------------------------------------------------
+        if(i.LE.4) then     ! Lecture des coord pression en (nlevelp1,lat,lon)
+           ierr = NF90_GET_VAR(nid,var3didin(i),apbp)
            print *,'read2_cas(apbp), on a lu ',i,name_var(i)
            if(ierr/=NF_NOERR) then
@@ -923,11 +895,7 @@
               stop "getvarup"
            endif
-!-----------------------------------------------------------------------
-           else if(i.gt.4.and.i.LE.12) then   ! Lecture des variables en (time,nlevel,lat,lon)
-#ifdef NC_DOUBLE
-           ierr = NF_GET_VAR_DOUBLE(nid,var3didin(i),resul1)
-#else
-           ierr = NF_GET_VAR_REAL(nid,var3didin(i),resul1)
-#endif
+           !-----------------------------------------------------------------------
+        else if(i.gt.4.and.i.LE.12) then   ! Lecture des variables en (time,nlevel,lat,lon)
+           ierr = NF90_GET_VAR(nid,var3didin(i),resul1)
            print *,'read2_cas(resul1), on a lu ',i,name_var(i)
            if(ierr/=NF_NOERR) then
@@ -935,12 +903,8 @@
               stop "getvarup"
            endif
-         print*,'Lecture de la variable #i ',i,name_var(i),minval(resul1),maxval(resul1)
-!-----------------------------------------------------------------------
-           else if(i.gt.12.and.i.LE.54) then   ! Lecture des variables en (time,nlevel,lat,lon)
-#ifdef NC_DOUBLE
-           ierr = NF_GET_VAR_DOUBLE(nid,var3didin(i),resul)
-#else
-           ierr = NF_GET_VAR_REAL(nid,var3didin(i),resul)
-#endif
+           print*,'Lecture de la variable #i ',i,name_var(i),minval(resul1),maxval(resul1)
+           !-----------------------------------------------------------------------
+        else if(i.gt.12.and.i.LE.54) then   ! Lecture des variables en (time,nlevel,lat,lon)
+           ierr = NF90_GET_VAR(nid,var3didin(i),resul)
            print *,'read2_cas(resul), on a lu ',i,name_var(i)
            if(ierr/=NF_NOERR) then
@@ -948,12 +912,8 @@
               stop "getvarup"
            endif
-         print*,'Lecture de la variable #i ',i,name_var(i),minval(resul),maxval(resul)
-!-----------------------------------------------------------------------
-           else if (i.gt.54.and.i.LE.65) then   ! Lecture des variables en (time,lat,lon)
-#ifdef NC_DOUBLE
-           ierr = NF_GET_VAR_DOUBLE(nid,var3didin(i),resul2)
-#else
-           ierr = NF_GET_VAR_REAL(nid,var3didin(i),resul2)
-#endif
+           print*,'Lecture de la variable #i ',i,name_var(i),minval(resul),maxval(resul)
+           !-----------------------------------------------------------------------
+        else if (i.gt.54.and.i.LE.65) then   ! Lecture des variables en (time,lat,lon)
+           ierr = NF90_GET_VAR(nid,var3didin(i),resul2)
            print *,'read2_cas(resul2), on a lu ',i,name_var(i)
            if(ierr/=NF_NOERR) then
@@ -961,12 +921,8 @@
               stop "getvarup"
            endif
-         print*,'Lecture de la variable #i  ',i,name_var(i),minval(resul2),maxval(resul2)
-!-----------------------------------------------------------------------
-           else     ! Lecture des constantes (lat,lon)
-#ifdef NC_DOUBLE
-           ierr = NF_GET_VAR_DOUBLE(nid,var3didin(i),resul3)
-#else
-           ierr = NF_GET_VAR_REAL(nid,var3didin(i),resul3)
-#endif
+           print*,'Lecture de la variable #i  ',i,name_var(i),minval(resul2),maxval(resul2)
+           !-----------------------------------------------------------------------
+        else     ! Lecture des constantes (lat,lon)
+           ierr = NF90_GET_VAR(nid,var3didin(i),resul3)
            print *,'read2_cas(resul3), on a lu ',i,name_var(i)
            if(ierr/=NF_NOERR) then
